#pragma once

#include "EHS.h"
#include "Str.h"

namespace ehs
{
	class EHS_LIB_IO URI
	{
	public:
		/// Encodes specialized characters in the URI.
		/// @param [in] in The URI to encode.
		/// @returns The encoded URI.
		static Str_8 Encode(const Str_8& in);

		/// Decodes specialized characters back into their readable format.
		/// @param [in] in The URI to decode.
		/// @returns The decoded URI.
		static Str_8 Decode(const Str_8& in);
	};
}